public class Triangle
{
   public int GetHauteur ()
   {
      return m_Hauteur;
   }
   public void SetHauteur (final int Hauteur)
      throws Exception
   {
      if (!EstHauteurValide (Hauteur))
         throw new Exception ("Hauteur invalide");
      SetHauteurBrut (Hauteur);
   }
   public void SetHauteurBrut (final int Hauteur)
   {
      m_Hauteur = Hauteur;
   }
   private static boolean EstHauteurValide (final int Hauteur)
   {
      return Hauteur >= GetHauteurMin () && Hauteur <= GetHauteurMax () && Hauteur % 2 != 0;
   }
   //
   // Retourne le nombre de "*" requis pour dessiner le Triangle
   //
   public int GetSurface ()
   {
      return GetHauteur () * GetHauteur (); // eh oui :)
   }

   public static int GetHauteurMin ()
   {
      return HAUTEUR_MIN;
   }
   public static int GetHauteurMax ()
   {
      return HAUTEUR_MAX;
   }

   private static final int
      HAUTEUR_MIN = 3,
      HAUTEUR_MAX = 19;
   private static final int
      HAUTEUR_DFAUT = HAUTEUR_MIN;
   private int m_Hauteur;
   public void Dessiner ()
   {
      for (int i = 1; i <= GetHauteur (); i++)
      {
         final int NbEspaces = GetHauteur () - i;
         for (int j = 0; j < NbEspaces; j++)
         {
            System.out.print (" ");
         }
         final int NbSymboles = i * 2 - 1;
         for (int j = 0; j < NbSymboles; j++)
         {
            System.out.print ("*");
         }
         System.out.println ();
      }
   }
   public Triangle ()
   {
      SetHauteurBrut (HAUTEUR_DFAUT);
   }
   public Triangle (final int Hauteur)
      throws Exception
   {
      SetHauteur (Hauteur);
   }
   public Triangle (final Triangle t)
   {
      SetHauteurBrut (t.GetHauteur ());
   }
   //
   public boolean equals (Triangle t)
   {
      return GetHauteur () == t.GetHauteur ();
   }
   public void copy (Triangle t)
   {
      SetHauteurBrut (t.GetHauteur ());
   }
}